--	The maxscript(MXS) heightmap Saturn render renderer Height map Geometry class 3ds max 9 above. Version:1.05
--	Copyright (c) 2015 JeriSoft R.M.G.Inc. JiSt
--	Permission is hereby granted, free of charge, to any person obtaining a copy
--	of this software and associated documentation files (the "Software"), to deal
--	in the Software without restriction, including without limitation the rights
--	to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
--	copies of the Software, and to permit persons to whom the Software is
--	furnished to do so, subject to the following conditions:
--
--	The above copyright notice and this permission notice shall be included in
--	all copies or substantial portions of the Software.
--
--	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
--	IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
--	FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
--	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
--	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
--	OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
--	THE SOFTWARE.
--	Except as contained in this notice,
--	the name(s) of the above copyright holders shall not be used in advertising
--	or otherwise to promote the sale,
--	use or other dealings in this Software without prior written authorization.
--	-
all_geo=#()
all_cam=#()
the_mid=[0,0,0]
X_dim=0
Y_dim=0
Z_dim=0
a_p_p = dotNetclass "System.Windows.Forms.Application"
fn minminArrX Arr =(
local a=Arr[1].min.x
for i=1 to Arr.count do(if Arr[i].min.x<a then a=Arr[i].min.x)
return a)
fn minminArrY Arr =(
local a=Arr[1].min.y
for i=1 to Arr.count do(if Arr[i].min.y<a then a=Arr[i].min.y)
return a)
fn minminArrZ Arr =(
local a=Arr[1].min.z
for i=1 to Arr.count do(if Arr[i].min.z<a then a=Arr[i].min.z)
return a)
fn maxmaxArrX Arr =(
local a=Arr[1].max.x
for i=1 to Arr.count do(if Arr[i].max.x>a then a=Arr[i].max.x)
return a)
fn maxmaxArrY Arr =(
local a=Arr[1].max.y
for i=1 to Arr.count do(if Arr[i].max.y>a then a=Arr[i].max.y)
return a)
fn maxmaxArrZ Arr =(
local a=Arr[1].max.z
for i=1 to Arr.count do(if Arr[i].max.z>a then a=Arr[i].max.z)
return a)
fn minimum a b = ( if a <b then a else b)
fn maximum a b = ( if a <b then b else a)
fn midariphm a b = ((a+b)/2)
rollout rollout1 "Heightmap" width:128 height:416
(
	label lbl1 "Please select Geometry" pos:[10,16] width:120 height:16
	label lbl2 "     and press Go" pos:[16,40] width:96 height:16
	button btngo "go" pos:[16,64] width:96 height:32
	button btnreset "Res" pos:[113,64] width:20 height:16 toolTip:"Reset params"
	button btncol1 "1" pos:[110,104] width:20 height:13 toolTip:"Colors preset 1"
	button btncol2 "2" pos:[110,117] width:20 height:13 toolTip:"Colors preset 2"
	button btncol3 "3" pos:[110,130] width:20 height:13 toolTip:"Colors preset 3"
	button btncol4 "4" pos:[110,143] width:20 height:13 toolTip:"Colors preset 4"
	button btncol5 "5" pos:[110,156] width:20 height:13 toolTip:"Colors preset 5"
	button btncol6 "6" pos:[110,169] width:20 height:13 toolTip:"Colors preset 6"
	button btncol7 "7" pos:[110,182] width:20 height:13 toolTip:"Colors preset 7"
	colorPicker cp1 "Background " pos:[8,104] width:98 height:16 color:(color 0 0 0)
	colorPicker cp2 "Flag_1 low   " pos:[8,128] width:98 height:16 color:(color 0 0 0)
	colorPicker cp3 "Flag_3 mid   " pos:[8,152] width:98 height:16 color:(color 127 127 127)
	colorPicker cp4 "Flag_2 hi      " pos:[8,176] width:98 height:16 color:(color 255 255 255)
	spinner spnflag3 "Flag_3 pos   " pos:[16,200] width:96 height:16 range:[0,100,50] type:#integer toolTip:"Middle color Position"
	spinner spnsize "Size             " pos:[16,224] width:96 height:16 range:[16,4096,256] type:#integer toolTip:"Render bitmap size(256x256)"
	spinner spnsamplmin "SamplesMIN" pos:[16,248] width:96 height:16 range:[0,4,2] type:#integer toolTip:"Render Samples Mimimum"
	spinner spnsamplmax "SamplesMax" pos:[16,272] width:96 height:16 range:[0,4,3] type:#integer toolTip:"Render Samples Maximum"
	spinner spnft "FilterType   " pos:[16,296] width:96 height:16 range:[0,4,0] type:#integer toolTip:"Render filter types: Box, Gauss, Triangle, Mitchell, Lanczos"
	spinner spnsmooth "Filter             " pos:[16,320] width:96 height:16 range:[0,8,1.9] type:#float toolTip:"Render filter power"
	spinner spnuvscale "UV+%scale" pos:[16,344] width:96 height:16 range:[-100,100,2] type:#float toolTip:"Planar UV scale up"
	spinner spnfov "Cam.FOV +" pos:[16,368] width:96 height:16 range:[-10,10,0.0] type:#float toolTip:"Camera Fild Of View +"
	progressBar pb1 "ProgressBar" pos:[8,392] width:112 height:16 value:100 color:[0,127,0]

	on btnreset pressed do(spnflag3.value=50;spnsize.value=256;spnsamplmin.value=2;spnsamplmax.value=3;spnft.value=0;spnsmooth.value=1.9;spnuvscale.value=2;spnfov.value=0.0)
	on btncol1 pressed do(cp1.color=(color 0 0 0);cp2.color=(color 0 0 0);cp3.color=(color 127 127 127);cp4.color=(color 255 255 255))
	on btncol2 pressed do(cp1.color=(color 255 255 255);cp2.color=(color 255 255 255);cp3.color=(color 127 127 127);cp4.color=(color 0 0 0))
	on btncol3 pressed do(cp1.color=(color 0 0 0);cp2.color=(color 255 0 0);cp3.color=(color 0 255 0);cp4.color=(color 0 0 255))
	on btncol4 pressed do(cp1.color=(color 0 0 0);cp2.color=(color 180 0 0);cp3.color=(color 255 255 0);cp4.color=(color 0 127 0))
	on btncol5 pressed do(cp1.color=(color 0 0 0);cp2.color=(color 0 0 255);cp3.color=(color 0 255 255);cp4.color=(color 255 255 0))
	on btncol6 pressed do(cp1.color=(color 128 128 255);cp2.color=(color 128 128 255);cp3.color=(color 128 0 128);cp4.color=(color 128 255 128))
	on btncol7 pressed do(cp1.color=(color 120 215 250);cp2.color=(color 255 0 0);cp3.color=(color 0 0 255);cp4.color=(color 255 255 255))
	on btngo pressed do
	(
	if selection.count > 0 do-- and superclassof $ == GeometryClass do
		(
	free all_cam
	all_cam =for d in $* where superclassof d == camera collect d
	for del=1 to all_cam.count do (delete all_cam[del])
	free all_geo
	all_geo = for nn in selection where superclassof nn == GeometryClass collect nn
		if all_geo.count > 0 do
			(
	pb1.color=[255,0,0]
	pb1.value=100
	escen = escapeEnable
	escapeEnable = true
	renderSceneDialog.cancel()
	rw=renderWidth
	rh=renderHeight
	rc=renderers.current
	bgcol = backgroundColor
	renderWidth = spnsize.value
	renderHeight = spnsize.value
	renderPixelAspect = 1.0
	rendTimeType = 1
	backgroundColor = cp1.color--(color 0 0 0)--(color 255 0 255)
	--		MATERIAL
	matpyr = Standardmaterial ()
	mapgrad = Gradient_Ramp ()
	matpyr.diffuseMap = mapgrad
	matpyr.Diffuse = color 0 0 0
	matpyr.ambient = color 0 0 0
	matpyr.Specular = color 0 0 0
	matpyr.glossiness = 0
	matpyr.Soften = 0
	matpyr.selfIllumAmount = 100
	matpyr.showInViewport = true
	meditMaterials[1] = matpyr
	mapgrad.Gradient_Ramp.Flag__1.color = cp2.color	--(color 0 0 0)
	mapgrad.Gradient_Ramp.Flag__2.color = cp4.color	--(color 255 255 255)
	mapgrad.Gradient_Ramp.Flag__3.color = cp3.color	--(color 127 127 127)
	mapgrad.Gradient_Ramp.Flag__3.position = spnflag3.value	--50
		
	for g = 1 to all_geo.count do
	(
	all_geo[g].material=null
	pir=all_geo[g]
	centerpivot pir;WorldAlignPivot pir;ResetXForm pir; collapseStack pir
	pir.material = matpyr
	--		UV
	addModifier pir (Uvwmap ())
	pir.modifiers[1].axis = 0
	dims = pir.max-pir.min
	pir.modifiers[1].length = ((dims.y/100)*spnuvscale.value)+dims.y
	pir.modifiers[1].height = ((dims.x/100)*spnuvscale.value)+dims.x
	pir.modifiers[1].width = ((dims.z/100)*spnuvscale.value)+dims.z
	)
	--max tool zoomextents all
	--#layout_1-- 1 viewport #layout_2v -- 2 viewports, vertical split, both same size #layout_2h -- 2 viewports, horizontal split, both same size #layout_2ht -- 2 viewports, horizontal split, top smaller #layout_2hb-- 2 viewports, horizontal split, top larger #layout_3vl-- 3 viewports, 2 on left, 1 on right #layout_3vr -- 3 viewports, 1 on left, 2 on right #layout_3ht-- 3 viewports, 2 on top, 1 on bottom #layout_3hb-- 3 viewports, 1 on top, 2 on bottom #layout_4-- 4 viewports, all same size #layout_4vl -- 4 viewports, 3 on left, 1 on right #layout_4vr -- 4 viewports, 1 on left, 3 on right #layout_4ht-- 4 viewports, 3 on top, 1 on bottom #layout_4hb-- 4 viewports, 1 on top, 3 on bottom
	tmpvport=viewport.getLayout()
	if tmpvport != #layout_4 then viewport.ResetAllViews()
	viewport.activeViewport = 1
	displaySafeFrames = true
	completeredraw()
	a_p_p.doEvents()
	if (maxversion())[1] >= 14000 and (nitr=NitrousGraphicsManager.GetActiveViewportSetting()) != undefined then
		(
		nitr=NitrousGraphicsManager.GetActiveViewportSetting()
		nitr.VisualStyleMode = 0
		nitr.LightOption = 1
		--nitr.UseEnvironmentBackgroundColorEnabled = true
		nitr.ShowHighlightEnabled = true
		nitr.ShadowsEnabled = false
		nitr.AmbientOcclusionEnabled = false
		actionMan.executeAction 0 "550"  -- Views: Viewport Visual Style Shaded
		)
		else
		(
		viewport.SetRenderLevel #smoothhighlights
		setUseEnvironmentMap true
		)
	--X_dim = $.max.x - $.min.x
	--Y_dim = $.max.y - $.min.y
	--Z_dim = $.max.z - $.min.z
	if all_geo.count == 1 then
	(
	the_mid = all_geo[1].center
	X_dim = all_geo[1].max.x - all_geo[1].min.x
	Y_dim = all_geo[1].max.y - all_geo[1].min.y
	Z_dim = all_geo[1].max.z - all_geo[1].min.z
	)
	else
	(
	mi_x=minminArrX all_geo
	ma_x=maxmaxArrX all_geo
	mi_y=minminArrY all_geo
	ma_y=maxmaxArrY all_geo
	mi_z=minminArrZ all_geo
	ma_z=maxmaxArrZ all_geo
	X_dim = ma_x - mi_x
	Y_dim = ma_y - mi_y
	Z_dim = ma_z - mi_z
	the_mid=[midariphm mi_x ma_x, midariphm mi_y ma_y, midariphm mi_z ma_z]
	)
	--		CAMERA
	m_cam = targetCamera ()
	m_cam.name = uniquename "HeightCam"
	m_cam.type = #free
	m_cam.type = #target
	m_cam.showCone = true
	m_cam.orthoProjection = true
	m_cam.pos = the_mid
	m_cam.target.pos = the_mid
	m_cam.target.pos.z = Z_dim
	--m_cam.pos.z = ((X_dim/2)/sin(45/2)) + Z_dim
	--m_cam.targetDistance = ((X_dim/2)/sin(45/2))
	m_cam.pos.z = (((maximum X_dim Y_dim)/2)/sin(45/2)) + Z_dim
	m_cam.targetDistance = (((maximum X_dim Y_dim)/2)/sin(45/2))
	m_cam.fov = 41.0728+spnfov.value	--	41.07
	
	viewport.setType #view_camera
	completeredraw()
	a_p_p.doEvents()
	--RendererClass.classes
	--theRenderer = for i in RendererClass.classes where matchPattern (i as string) pattern:"Quicksilver*"collect i
	--theRenderer = for i in RendererClass.classes where matchPattern (i as string) pattern:"mental_ray*"collect i
	--theRenderer = for i in RendererClass.classes where matchPattern (i as string) pattern:"Default*"collect i
	theRenderer = for i in RendererClass.classes where matchPattern (i as string) pattern:"mental_ray*"collect i
	if theRenderer.count == 1 then --mental_ray
		(
		renderers.current = theRenderer[1]()
		renderers.current.FinalGatherEnable2 = false
		renderers.current.MinimumSamples = spnsamplmin.value	--1
		renderers.current.MaximumSamples = spnsamplmax.value	--4
		renderers.current.filter = spnft.value	--4 --Lanczos
		renderers.current.BoxFilterWidth = spnsmooth.value	--	1
		renderers.current.BoxFilterHeight = spnsmooth.value	--	1
		renderers.current.GaussFilterWidth = spnsmooth.value	--	3
		renderers.current.GaussFilterHeight = spnsmooth.value	--	3
		renderers.current.TriangleFilterWidth = spnsmooth.value	--	2
		renderers.current.TriangleFilterHeight = spnsmooth.value	--	2
		renderers.current.MitchellFilterWidth = spnsmooth.value	--	4
		renderers.current.MitchellFilterHeight = spnsmooth.value	--	4
		renderers.current.LanczosFilterWidth = spnsmooth.value	--	4
		renderers.current.LanczosFilterHeight = spnsmooth.value	--	4
		) else (renderers.current = RendererClass.classes[1])
	--rrr=render()
	max hide inv
	rrr=render m_cam quiet:true--camera:$HeightCam quiet:true
	setclipboardBitmap rrr
	renderers.current=rc
	--renderHeight = rh
	--renderWidth = rw
	backgroundColor = bgcol
	escapeEnable = escen
	viewport.setType #view_top
	max unhide all
	completeredraw()
	a_p_p.doEvents()
	--select m_cam
	max zoomext sel
	max zoomext sel
	pb1.color=[0,127,0]
	pb1.value=100
	--max tool zoomextents
			)
		)
	)
	on spnsamplmin changed value do
		(if spnsamplmin.value>spnsamplmax.value then spnsamplmax.value=spnsamplmin.value)
	on spnsamplmin entered do
		(if spnsamplmin.value>spnsamplmax.value then spnsamplmax.value=spnsamplmin.value)
	on spnsamplmax changed value do
		(if spnsamplmax.value<spnsamplmin.value then (spnsamplmin.value=spnsamplmax.value))
	on spnsamplmax entered do
		(if spnsamplmax.value<spnsamplmin.value then spnsamplmin.value=spnsamplmax.value)
)
	 	if rollout1RolloutFloater != undefined then (closerolloutfloater rollout1RolloutFloater)
		rollout1RolloutFloater = newrolloutfloater "Heightmap" 145 445 40 145
		addrollout rollout1 rollout1RolloutFloater
		clearListener()

